//*****************************************************************
// 
//  JAVA Source for com.idautomation.aztec; 2010
//  
//	 Copyright IDAutomation.com, Inc. All rights reserved.
//	Redistribution and use of this code in source and/or binary 
//	forms, with or without modification, are permitted provided 
//	that: (1) all copies of the source code retain the above 
//	unmodified copyright notice and this entire unmodified 
//	section of text, (2) You or Your organization owns a valid 
//	Developer License to this product from IDAutomation.com 
//	and, (3) when any portion of this code is bundled in any 
//	form with an application, a valid notice must be provided 
//	within the user documentation, start-up screen or in the 
//	help-about section of the application that specifies 
//	IDAutomation.com as the provider of the Software bundled 
//	with the application.
//*****************************************************************


package com.idautomation.aztec;

import java.awt.*;
import java.applet.*;
import java.io.*;

/** This is the Aztec applet that creates a barcode from the Aztec class. */

public class AztecApplet extends Applet
{

  // ** updated for servlet operation 5/31/2001
	public Aztec BC=null;
  public boolean isStandalone=false;
  // ** end of update

	public AztecApplet() 
	{
		this.setLayout(new java.awt.BorderLayout());
	}

	public void start() {
		BC.paint(this.getGraphics());
		BC.autoSize=false;
	}

	public void refresh() {
    BC.paint(BC.getGraphics());
		this.paintAll(this.getGraphics());
	}

	public void init() {	
		try
		{
				
		// create bar code Aztec
		if (BC==null) BC=new Aztec();	
		
		this.add("Center",BC);		

		initParam("X");
		initParam("BAR_COLOR");
		initParam("BACK_COLOR");
		initParam("BARCODE");
		initParam("D");
		initParam("ROTATE");
                initParam("O");
                initParam("LM");
                initParam("TM");
                initParam("BGC");
                initParam("BC");
                initParam("IR");

		// Aztec specific
		initParam("RI");
		initParam("PT");
		initParam("MA");
		initParam("NS");
		initParam("ECL");
		}
		catch (Exception e)
	    {//Catch exception if any
	      System.err.println("Error: " + e.getMessage());
	    }			
	}

	private void initParam(String p) {
		String v=getStringParam(p,"");
		if (v.length()==0) return;
	    setParameter(p,v);
	}

	public void setParameter(String p,String v) 
	{

            if (v==null) return;
		
		if (p.compareTo("ROTATE")==0) BC.rotate=(int) (new Double(v).doubleValue());
		
		if (p.compareTo("X")==0) BC.setXDimensionCM((double) (new Double(v).doubleValue()));

		if (p.compareTo("LM")==0) BC.leftMarginCM=new Double(v).doubleValue();

		if (p.compareTo("TM")==0) BC.topMarginCM=new Double(v).doubleValue();

		if (p.compareTo("BAR_COLOR")==0) BC.barColor=convertColor(v);

		if (p.compareTo("BACK_COLOR")==0) BC.backColor=convertColor(v);

		if (p.compareTo("BARCODE")==0 || p.compareTo("D")==0) BC.setDataToEncode(v);
                
                if (p.compareTo("O")==0) BC.rotate=(int) (new Double(v).doubleValue());
                
                if (p.compareTo("BC")==0) BC.barColor=convertColor(v);

		if (p.compareTo("BGC")==0) BC.backColor=convertColor(v);
            
                if (p.compareTo("IR")==0) BC.setPixelsPerCM(new Integer(v).intValue());
            
		if (p.compareTo("MA")==0) BC.setMessageAppend(v);
		
                if (p.compareTo("RI")==0)
                {
                    String RIParameter = v;
                    if(RIParameter.toUpperCase().compareTo("Y") == 0 || RIParameter.toUpperCase().compareTo("YES") == 0 ||
                       RIParameter.toUpperCase().compareTo("TRUE") == 0 || RIParameter.toUpperCase().compareTo("T") == 0)
                        BC.readerInit = true;
                    else
                        BC.readerInit = false;

                }
		
		if (p.compareTo("ECL")==0)
		{
			int ECLVal = new Integer(v).intValue();
			if (ECLVal >= 1 && ECLVal <= 99)
				BC.setErrorCorrectionLevel(ECLVal);
			else
				BC.setErrorCorrectionLevel(0);				
		}
		
		if (p.compareTo("NS")==0)
		{
			int NumOfSymbols = new Integer(v).intValue();
			if (NumOfSymbols < 1 )
				BC.numOfSym = 1;
			else
				BC.numOfSym = NumOfSymbols;		
		}
		if (p.compareTo("PT")==0)
                {
                    String PTParameter = v;
                    if(PTParameter.toUpperCase().compareTo("Y") == 0 || PTParameter.toUpperCase().compareTo("YES") == 0 ||
                       PTParameter.toUpperCase().compareTo("TRUE") == 0 || PTParameter.toUpperCase().compareTo("T") == 0)
                        BC.applyTilde = true;
                    else
                        BC.applyTilde = false;

                }
	}

    // function to convert a String parameter to a color
    public java.awt.Color convertColor(String c) 
    {
        if (c.toUpperCase().compareTo("NULL")==0) return null;
        if (c.toUpperCase().compareTo("RED")==0) return java.awt.Color.red;
        if (c.toUpperCase().compareTo("BLACK")==0) return java.awt.Color.black;
        if (c.toUpperCase().compareTo("BLUE")==0) return java.awt.Color.blue;
        if (c.toUpperCase().compareTo("CYAN")==0) return java.awt.Color.cyan;
        if (c.toUpperCase().compareTo("DARKGRAY")==0) return java.awt.Color.darkGray;
        if (c.toUpperCase().compareTo("GRAY")==0) return java.awt.Color.gray;
        if (c.toUpperCase().compareTo("GREEN")==0) return java.awt.Color.green;
        if (c.toUpperCase().compareTo("LIGHTGRAY")==0) return java.awt.Color.lightGray;
        if (c.toUpperCase().compareTo("MAGENTA")==0) return java.awt.Color.magenta;
        if (c.toUpperCase().compareTo("ORANGE")==0) return java.awt.Color.orange;
        if (c.toUpperCase().compareTo("PINK")==0) return java.awt.Color.pink;
        if (c.toUpperCase().compareTo("WHITE")==0) return java.awt.Color.white;
        if (c.toUpperCase().compareTo("YELLOW")==0) return java.awt.Color.yellow;
        try 
        {
            return java.awt.Color.decode(c);
        } 
        catch (Exception e) 
        {
            return java.awt.Color.black;
        }
    }

  // convert an applet parameter to a Font
  public java.awt.Font convertFont(String f) {

    String[] items=convertList(f);

   if (items==null) return null;

    if (items.length<3) return null;

    int s=java.awt.Font.PLAIN;
    if (items[1].compareTo("BOLD")==0) s=java.awt.Font.BOLD;
    if (items[1].compareTo("ITALIC")==0) s=java.awt.Font.ITALIC;

    try {
    return new java.awt.Font(items[0],s,new Integer(items[2]).intValue());
    }
    catch (Exception e) {return null;}

  }

  // ** updated for servlet operation 5/31/2001
  // get a parameter as string
  protected String getStringParam(String Param,String def) {

      return this.getParameter(Param, def);


    }


  //Get a parameter value
  private String getParameter(String key, String def) {


    if (isStandalone) return def;

    if (this.getParameter(key) != null) return this.getParameter(key) ;
    else return def;
  }

  private String[] convertList(String items){

   String[] itema=new String[500];
   int itemCount=0;

   // count number of items
   int p=items.indexOf("|");
   while (p>=0) {
      itema[itemCount++]=items.substring(0,p);
      items=items.substring(p+1,items.length());
      p=items.indexOf("|");
   }

   if (items.compareTo("")!=0) itema[itemCount++]=items;

   if (itemCount==0) return null;

   String[] result=new String[itemCount];
   for (int i=0;i<itemCount;i++) result[i]=itema[i];

   return result;

 }

  private Integer getIntParam(String Param,Integer def) {

    try {
      String s=this.getParameter(Param ,"");
      if (s.compareTo("")==0) return def;
      return new Integer(s);
    }
    catch(Exception e) {
      return def;
    }
   }

   private Double getDoubleParam(String Param,Double def) {

      try {
       String s=this.getParameter(Param ,"");
      if (s.compareTo("")==0) return def;
     return new Double(s);
    }
    catch(Exception e) {
      return def;
    }
    }
    // ** end of update

}
